#2747 closed defect (fixed)

dlerror non-conformance

Reported by: Patrick Gauvin Owned by: Chris Johns
Priority: normal Milestone: 4.11.3
Component: lib/dl Version: 4.11
Severity: normal Keywords:
Cc: Ryan Slabaugh Blocked By:
Blocking: #3298

Description

Expected behavior of dlerror:

  • The error is cleared after each invocation
  • NULL is returned when no error is set
  • Return value is char *, not const char *

http://pubs.opengroup.org/onlinepubs/9699919799/functions/dlerror.html

I've attached patches that address these issues, please critique them and I will submit to the development mailing list. They should also apply to master, but they were generated against 4.11.

Development Environment:

arm-rtems4.11-gcc (GCC) 4.9.3 20150626 (RTEMS 4.11, RSB 1675a733536d1aec2020011e5e522497a442561a (HEAD, origin/4.11, 4.11), Newlib 2.2.0.20150423)

  • RTEMS Configure Options:

../rtems/configure --target=arm-rtems4.11 --enable-rtemsbsp="xilinx_zynq_a9_qemu xilinx_zynq_zedboard xilinx_zynq_csp_cots xilinx_zynq_csp_hybrid" --enable-tests=samples --enable-posix --prefix=$HOME/development/rtems/4.11 --disable-networking

Change History (10)

Changed on Jun 26, 2016 at 5:36:41 PM by Patrick Gauvin

comment:1 Changed on Aug 14, 2017 at 12:12:35 AM by Chris Johns

Milestone: 4.11.3

comment:2 Changed on Feb 5, 2018 at 4:41:10 AM by Chris Johns

Status: newaccepted

comment:3 Changed on Feb 8, 2018 at 3:37:08 AM by Chris Johns

Blocking: 3298 added

comment:4 Changed on Feb 8, 2018 at 10:32:42 PM by Chris Johns <chrisj@…>

In 7093cb5e/rtems:

libtest/dl01: Add dlerror tests.

Update #2747

comment:5 Changed on Feb 8, 2018 at 10:34:06 PM by Chris Johns

Resolution: fixed
Status: acceptedclosed

comment:6 Changed on Feb 16, 2018 at 2:16:46 AM by Chris Johns <chrisj@…>

In 7093cb5e/rtems:

libtest/dl01: Add dlerror tests.

Update #2747

Note: See TracTickets for help on using tickets.